#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "sleep4xi.py">
#<abstract4xi abstract = "provides sleep services"/>
#<refer4xi reference = "yourDragon4Xi"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# ------------------------------------------------------------------------------------------------- 
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'omega2sleep4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import datetime
import time
from time import gmtime, strftime
#"
#/>
# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:                 # most-common ones
    import time         
    from time import gmtime, strftime 
except:
    pass
try:                 # rare ones
    import datetime
except:
    pass 
       
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from timeouterror4xi import TimeoutError4Xi
from print4xi import print4xi
from time4xi import time4xi        
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi Globals                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global KB4Sleep
global default2sleep 
#"
#/>
# -------------------------------------------------------------------------------------------------
# Settings (seconds - 0.01seconds equals to 10ms)
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
KB4Sleep = {'answer_challenge4xi2answer_challenge4xi': 0.02, 
            'ApplyResult4Xi2wait': 0.02,
            'ApplyResult4Xi2get': 0.02,
            'ApplyResult4Xi2successful': 0.02,            
            
            'BaseManager4Xi2join': 0.02,
            'BaseManager4Xi2_finalize_manager': 0.02,
            'BaseProxy4Xi2_connect':  0.02,
            
            'Condition4Xi2wait': 0.02,
            'ConditionProxy4Xi2wait': 0.02,
            
            'deliver_challenge4xi2deliver_challenge4xi': 0.02,
            'DummyProcess4Xi2__init__': 0.02,            
            
            'Event4Xi2wait': 0.02,
            'EventProxy4Xi2wait': 0.02,  
            
            'IMapIterator4Xi2next': 0.02,
            'init_listener4xi2init_listener4xi': 0.02,
            
            'JoinableQueue4Xi2put': 0.04,              
            
            'MainProcess4Xi2join': 0.08,
            
            'PipeClient4Xi2PipeClient4Xi': 0.02,
            'PipeListener4Xi2__init__': 0.02,
            'Popen4Xi2start': 0.02,            
            'Popen4Xi2wait': 0.02,
            'Popen4Xi2poll': 0.02,
            'Popen4Xi2terminate': 0.01,
            
            'Process4Xi2__init__': 0.02,
            'Process4Xi2run': 0.02, 
            'Process4Xi2start': 0.02,    
            'Process4Xi2terminate': 0.02,    
            'Process4Xi2join': 0.02,    
            'Process4Xi2is_alive': 0.02, 
            'Process4Xi2__repr__': 0.02,    
            'Process4Xi2_bootstrap': 0.02,    
            'Process4Xi2sense': 0.02,    
            'Process4Xi2reason': 0.02,    
            'Process4Xi2ace': 0.02,                                                                                 
            
            
            'Queue4Xi2put': 0.02, 
            'Queue4Xi2get': 0.04,
            'SocketClient4Xi': 0.02,
            
            'SyncManager4Xi2join': 0.08,
            'SyncManager4Xi2get_server': 0.08,
            'SyncManager4Xi2start': 0.08, 
            'SyncManager4Xi2_finalize_manager': 0.08,
            
            'test_sphere4xi2receive': 2.0, 
            'test_sphere4xi2get': 8.0,                          
            
            '_cleanup4xi2_cleanup4xi2': 0.02,
            '_MainProcess4Xi2join': 0.02}
                 
             
default2sleep = 0.01  # 10 milliseconds sleep even if the given parameters are wrong 
#"
#"/>
 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "omega2sleep4xi" usage = "
#   provides sleep services
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def omega2sleep4xi (class2sleep, method2sleep):
    '''
    sleeps milliseconds to the caller based on given class and method
    '''
    global KB4Sleep
    global default2sleep 
       
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    class2print = 'omega2sleep4xi'
    method2print = 'omega2sleep4xi'
    
    message2print = "{started" + "; omega2sleep4xi-started: " + str(omega2sleep4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # <function omega2sleep4xi at 0x00000000031822F0>
    # 04:41:45 04/19/13 Pacific Daylight Time
        
    message2print = "{passed" + "; class2sleep-passed-to-omega2sleep4xi: " + str(class2sleep) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    # MainProcess4Xi
        
    message2print = "{passed" + "; method2sleep-passed-to-omega2sleep4xi: " + str(method2sleep) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    # join            
            
    keys2KB = KB4Sleep.keys()
   
    key2caller = str(class2sleep) + "2" + str(method2sleep)

    message2print = "{set" + "; key2caller-set-by-omega2sleep4xi to: " + str(key2caller)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    # MainProcess4Xi2join
        
    sleep2xi = default2sleep
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    for key2xi in sorted(keys2KB):
        if key2xi == key2caller:
            sleep2xi = KB4Sleep[key2caller]
            
            message2print = "{tuned" + "; sleep2xi-tuned-by-omega2sleep4xi: " + str(sleep2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 0.08
                    
            break
        else:
            pass
               
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    message2print = "{sleeping" + "; sleep2xi-sleeping-by-omega2sleep4xi: " + str(sleep2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                      
    # 0.08
            
    time.sleep(sleep2xi)                  

    message2print = "{slept" + "; sleep2xi-slept-by-omega2sleep4xi: " + str(sleep2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 0.08
                       
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    message2print = "{returning" + "; omega2sleep4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 04:41:45 04/19/13 Pacific Daylight Time          
        
    return               
        
        
    
#</function4xi>
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#  test_timout4xi.txt
#  sense-timout4xi.xml
#  reason-timout4xi.xml
#  ace-timout4xi.xml
#"
#/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of sleep4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
